/* book page 38 */
#include <mpi.h>
#define TAG1 100
#define TAG2 200
int main (int argc, char **argv) {
    int rank;
    MPI_Status status;
    double msg1[50], msg2[10];
    MPI_Init(&argc, &argv);
    MPI_Comm_rank (MPI_COMM_WORLD, &rank);
    if (rank==0) {
        MPI_Recv(msg2, 10, MPI_DOUBLE, 1, TAG2,
                 MPI_COMM_WORLD, &status );
        MPI_Send(msg1,50,MPI_DOUBLE,1,TAG1,MPI_COMM_WORLD);}
    else if (rank==1) {
        MPI_Send(msg2,10,MPI_DOUBLE,0,TAG2,MPI_COMM_WORLD);
        MPI_Recv(msg1, 50, MPI_DOUBLE, 0, TAG1,
                 MPI_COMM_WORLD, &status);}
    MPI_Finalize();
    return (0); }
